module m_quadtree

    use parameters, only : NODATA

    implicit none

    contains

    subroutine make_quadtree(kmax, mmax, nmax, lgrmin, use_2d_flow, area_mask, lg, quad_idx,&
        n_cells, n_line_u, n_line_v)
    !!! Entry point for creating quadtree by setting lg array and then finding number of active cells and lines.
        use parameters, only : NODATA

        integer, intent(in) :: kmax ! Maximum refinement levels
        integer, intent(in) :: mmax(:) ! X Dimension of each refinement level
        integer, intent(in) :: nmax(:) ! Y Dimension of each refinement level
        integer, intent(in) :: lgrmin ! Number of pixels in cell of smallest refinement level
        integer, intent(in) :: use_2d_flow  ! Whether to add flowlines
        integer*1, intent(in) :: area_mask(:, :) ! Array with active pixels of model.
        integer, intent(inout) :: lg(:, :) ! Array with all refinement levels.
        integer, intent(inout) :: quad_idx(:, :) ! Array with idx of cell at lg refinement locations
        integer, intent(inout) :: n_cells ! counter for active cells
        integer, intent(inout) :: n_line_u ! counter for active u lines
        integer, intent(inout) :: n_line_v ! counter for active v lines
        integer :: k
        integer :: m, n

        write(*,*) '** INFO: Start making quadtree.'
        do m=1, mmax(kmax)
            do n=1, nmax(kmax)
                call divide(kmax, m, n, lg)
            enddo
        enddo
        call balance_quadtree(kmax, mmax, nmax, lg)
        call find_active_2d_comp_cells(&
            kmax, mmax, nmax, lgrmin, use_2d_flow > 0, lg, area_mask, quad_idx, n_cells, n_line_u, n_line_v&
        )
        write(*,*) '** INFO: Done making quadtree.'

    end subroutine make_quadtree

    recursive subroutine divide(k, m, n, lg) !ip, jp, 
    !!! Recursive subroutine to set correct refinement levels on lg refinement array.
        use m_grid_utils, only : get_lg_corners
        use parameters, only : NODATA

        integer, intent(in) :: k
        integer, intent(in) :: m
        integer, intent(in) :: n
        integer, intent(inout) :: lg(:,:)
        integer :: k1
        integer :: mn(4)
        integer :: m_n, n_n

        mn = get_lg_corners(k, m, n)
        if(any(lg(mn(1):mn(3),mn(2):mn(4)) < k).and.k>1) then
            k1 = k-1
            m_n=2*m-1
            n_n=2*n-1
            lg(mn(1):mn(3),mn(2):mn(4)) = min(lg(mn(1):mn(3),mn(2):mn(4)), k1)
            call divide(k1, m_n, n_n, lg)
            call divide(k1, m_n+1, n_n, lg)
            call divide(k1, m_n, n_n+1, lg)
            call divide(k1, m_n+1, n_n+1, lg)
        endif

    end subroutine divide

    subroutine balance_quadtree(kmax, mmax, nmax, lg)
    !!! Balancing out refinement levels, so that neighbouring cells are never more than 1 refinement level apart.
        integer, intent(in) :: kmax
        integer, intent(in) :: mmax(:)
        integer, intent(in) :: nmax(:)
        integer, intent(inout) :: lg(:,:)
        integer :: k, k1
        integer :: m, n, m1, n1

        do k=1,kmax-1
            do n=1, nmax(1)
                do m=1,mmax(1)-1
                    if(lg(m,n) == k .and. lg(m+1,n)>k+1) then
                        lg(m+1,n)=k+1
                    endif
                    if(lg(m,n) > k+1 .and. lg(m+1,n)==k) then
                        lg(m,n)=k+1
                    endif
                enddo
            enddo
            do n=1,nmax(1)-1
                do m=1, mmax(1)
                    if (lg(m,n)==k.and.lg(m,n+1)>k+1) then
                        lg(m,n+1)=k+1
                    endif
                    if (lg(m,n)>k+1.and.lg(m,n+1)==k) then
                        lg(m,n)=k+1
                    endif
                enddo
            enddo

            
            do n=1, nmax(kmax)
                do m=1, mmax(kmax)
                    call divide(kmax, m, n, lg)
                enddo
            enddo
        enddo

    end subroutine balance_quadtree

    subroutine find_active_2d_comp_cells(&
        kmax, mmax, nmax, lgrmin, use_2d_flow, lg, area_mask, quad_idx, n_cells, n_line_u, n_line_v&
    )
    !!! Counting active cells and lines based on area_mask of active pixels.
        use m_grid_utils, only : get_lg_corners, get_pix_corners, crop_pix_coords_to_raster, pad_area_mask
        use m_cells, only : set_2d_computational_lines
        use parameters, only : NODATA

        integer, intent(in) :: kmax
        integer, intent(in) :: mmax(:)
        integer, intent(in) :: nmax(:)
        integer, intent(in) :: lgrmin
        logical, intent(in) :: use_2d_flow
        integer, intent(inout) :: lg(:,:)
        integer*1, intent(in) :: area_mask(:,:)
        integer, intent(inout) :: quad_idx(:,:)
        integer, intent(inout) :: n_line_u
        integer, intent(inout) :: n_line_v
        integer*1, allocatable:: area_mask_padded(:, :)
        integer :: k
        integer :: m,n
        integer :: mn(4)
        integer :: i0, i1, j0, j1, i2, i3, j2, j3
        integer :: n_cells
        
        
        n_cells = 0
        n_line_u = 0
        n_line_v = 0
        quad_idx = 0
        call get_pix_corners(kmax, mmax(kmax), nmax(kmax), lgrmin, i0, i1, j0, j1)
        area_mask_padded = pad_area_mask(area_mask, i0, i1, j0, j1) 
        do k=kmax,1,-1
            do m=1,mmax(k)
                do n=1,nmax(k)
                    call get_pix_corners(k, m, n, lgrmin, i0, i1, j0, j1)
                    mn = get_lg_corners(k, m, n)
                    i1 = min(i1, size(area_mask, 1))
                    j1 = min(j1, size(area_mask, 2))
                    if (all(lg(mn(1):mn(3),mn(2):mn(4)) == k)) then !! TODO: CHECK OF MODEL AREA CHECK IS NECESSARY???
                        if (all(area_mask_padded(i0:i1, j0:j1) == 0)) then
                            lg(mn(1):mn(3),mn(2):mn(4)) = -99
                        else
                            n_cells = n_cells + 1
                            lg(mn(1):mn(3),mn(2):mn(4)) = k   !! DO WE OVERWRITE AND FAVOR LARGER CELLS
                            quad_idx(mn(1):mn(3),mn(2):mn(4)) = n_cells
                            if (use_2d_flow) then
                                call set_2d_computational_lines(&
                                    n_line_u, n_line_v, k, m, n, mn, lg, lgrmin, area_mask_padded, quad_idx&
                                )
                            endif
                        endif
                    endif
                enddo
            enddo
        enddo
        deallocate(area_mask_padded)
        write(*,*) '** INFO: No. active 2D computational cells: ', n_cells
        write(*,*) '** INFO: Number of 2D Surface flow lines is: ', n_line_u, n_line_v

    end subroutine find_active_2d_comp_cells


end module m_quadtree

module m_cells

    implicit none

    contains

    subroutine set_2d_computational_nodes_lines(origin, lgrmin, kmax, mmax, nmax, dx,&
        lg, nodk, nodm, nodn, quad_idx, bounds, coords, pixel_coords,&
        area_mask, line, cross_pix_coords, n_line_u, n_line_v)
        !!! Entry point for setting nodes and lines and there necessary attributes.
        use m_grid_utils, only : get_lg_corners, get_cell_bbox, get_pix_corners, pad_area_mask

        double precision, intent(in) :: origin(2) ! Origin of Quadtree grid
        integer, intent(in) :: lgrmin ! Number of pixels in cell of smallest refinement level
        integer, intent(in) :: kmax ! Maximum refinement levels
        integer, intent(in) :: mmax(:) ! X Dimension of each refinement level
        integer, intent(in) :: nmax(:) ! Y Dimension of each refinement level
        double precision, intent(in) :: dx(:) ! Cell size of each refinement level
        integer, intent(inout) :: nodk(:) ! Array with refinement level of comp node
        integer, intent(inout) :: nodm(:) ! Array with x or m coordinate on its refinement level grid
        integer, intent(inout) :: nodn(:) ! Array with y or n coordinate on its refinement level grid
        integer, intent(inout) :: lg(:, :) ! Array with all refinement levels.
        integer, intent(inout) :: quad_idx(:, :) ! Array with idx of cell at lg refinement locations
        double precision, intent(inout) :: bounds(:, :) ! Bbox of comp cell
        double precision, intent(inout) :: coords(:, :) ! Cell center coordinates
        integer, intent(inout) :: pixel_coords(:, :) ! pixel bbox of comp cell
        integer*1, intent(inout) :: area_mask(:, :) ! Array with active pixels of model.
        integer, intent(inout) :: line(:, :) ! Array with connecting nodes of line.
        integer, intent(inout) :: cross_pix_coords(:, :) ! Array pixel indices of line interface
        integer, intent(in) :: n_line_u ! Number of active u-dir lines.
        integer, intent(in) :: n_line_v  ! Number of active v-dir lines.
        integer*1, allocatable :: area_mask_padded(:, :)
        integer :: nod
        integer :: k
        integer :: i0, i1, j0, j1
        integer :: l_u, l_v
        integer :: m, n
        integer :: mn(4)
        logical :: use_2d_flow

        write(*,*) '** INFO: Start setting 2D calculation cells.'
        nod = 1
        use_2d_flow = ((n_line_u > 0) .or. (n_line_v > 0))
        l_u = 0
        l_v = n_line_u
        line = 0
        call get_pix_corners(kmax, mmax(kmax), nmax(kmax), lgrmin, i0, i1, j0, j1)
        if (use_2d_flow) then
            area_mask_padded = pad_area_mask(area_mask, i0, i1, j0, j1) 
        endif
        do k=kmax,1,-1
            do m=1,mmax(k)
                do n=1,nmax(k)
                    mn = get_lg_corners(k, m, n)
                    if(all(quad_idx(mn(1):mn(3),mn(2):mn(4)) == nod)) then
                        nodk(nod) = k
                        nodm(nod) = m
                        nodn(nod) = n
                        bounds(nod,:) = get_cell_bbox(origin(1), origin(2), m, n, dx(k))
                        coords(nod, :) = (/ 0.5d0 * (bounds(nod,1) + bounds(nod,3)), 0.5d0 * (bounds(nod,2) + bounds(nod,4)) /)
                        call get_pix_corners(k, m, n, lgrmin, i0, i1, j0, j1)
                        ! We inverse the y-axis for pixel_coords to comply with geotiffs in future use.
                        ! And do some index fiddling because python starts indexing at 0 and has open end indexing.
                        pixel_coords(nod, :) = (/ i0 - 1, j0 - 1, i1, j1 /)
                        if (use_2d_flow) then
                            call set_2d_computational_lines(&
                                l_u, l_v, k, m, n, mn, lg, lgrmin, area_mask_padded, quad_idx, nod, line, cross_pix_coords&
                            )
                        endif
                        nod = nod + 1
                    else
                        continue
                    endif
                enddo
            enddo
        enddo
        if (use_2d_flow) then
            deallocate(area_mask_padded)
        endif
        write(*,*) '** INFO: Number of 2D nodes is: ', nod - 1
        write(*,*) '** INFO: Number of 2D lines is: ', l_u + (l_v - l_u)
        write(*,*) '** INFO: Done setting 2D calculation cells.'

    end subroutine set_2d_computational_nodes_lines

    subroutine set_2d_computational_lines(l_u, l_v, k, m, n, mn, lg, lgrmin, area_mask, quad_idx, nod, line, cross_pix_coords)

        use m_grid_utils, only : get_lg_corners, get_pix_corners, crop_pix_coords_to_raster

        integer, intent(inout) :: l_u
        integer, intent(inout) :: l_v
        integer, intent(in) :: k
        integer, intent(in) :: m
        integer, intent(in) :: n
        integer, intent(in) :: mn(4)
        integer, intent(in) :: lg(:,:)
        integer, intent(in) :: lgrmin
        integer*1, intent(in) :: area_mask(:,:)
        integer, intent(in) :: quad_idx(:,:)
        integer, intent(in), optional :: nod
        integer, intent(inout), optional :: line(:,:)
        integer, intent(inout), optional :: cross_pix_coords(:,:)
        integer :: i0,i1,j0,j1,i2,i3,j2,j3
        integer :: neighbour

        !! U direction

        call get_pix_corners(k, m, n, lgrmin, i0, i1, j0, j1, i2, i3, j2, j3)

        !!!!!!!!!!!!!!!!!!!!!!!!!
        !!!!! U - direction !!!!!
        !!!!!!!!!!!!!!!!!!!!!!!!!
        if (mn(3) < size(quad_idx, 1)) then
            if(lg(mn(3)+1, mn(2)) == k .and. any(minval(area_mask(i1:i1+1,j0:j1), 1) > 0)) then
                l_u = l_u + 1
                if (present(line)) then
                    neighbour = quad_idx(mn(3)+1, mn(2)) 
                    ! We substract 1 from index to comply with C/python indexing.
                    line(l_u,:) = (/ nod - 1, neighbour - 1/)
                    cross_pix_coords(l_u,:) = (/ i1, j0 - 1, i1, j1 /) ! Python indexing so -1 at start slice
                endif
            else
                if (lg(mn(3)+1, mn(2)) == k-1 .and. any(minval(area_mask(i1:i1+1,j0:j2), 1) > 0)) then
                    l_u = l_u + 1
                    if (present(line)) then
                        neighbour = quad_idx(mn(3)+1, mn(2)) 
                        ! We substract 1 from index to comply with C/python indexing.
                        line(l_u,:) = (/ nod - 1, neighbour - 1 /)
                        cross_pix_coords(l_u,:) = (/ i1, j0 - 1, i1, j2 /) ! Python indexing so -1 at start slice
                    endif
                endif
                if (lg(mn(3)+1, mn(4)) == k-1 .and. any(minval(area_mask(i1:i1+1,j3:j1), 1) > 0)) then
                    l_u = l_u + 1
                    if (present(line)) then
                        neighbour = quad_idx(mn(3)+1,mn(4))
                        ! We substract 1 from index to comply with C/python indexing.
                        line(l_u,:) = (/ nod - 1, neighbour - 1 /)
                        cross_pix_coords(l_u,:) = (/ i1, j3 - 1, i1, j1 /) ! Python indexing so -1 at start slice
                    endif
                endif
            endif
        endif

        if (mn(1) > 1) then
            if(lg(mn(1)-1, mn(2)) == k-1 .and. any(minval(area_mask(i0-1:i0,j0:j2), 1) > 0)) then
                l_u = l_u + 1
                if (present(line)) then
                    neighbour = quad_idx(mn(1)-1, mn(2))
                    ! We substract 1 from index to comply with C/python indexing.
                    line(l_u,:) = (/ neighbour - 1, nod - 1 /)
                    cross_pix_coords(l_u,:) = (/ i0 - 1, j0 - 1, i0 - 1, j2 /)
                endif
            endif
            if(lg(mn(1)-1, mn(4)) == k-1 .and. any(minval(area_mask(i0-1:i0,j3:j1), 1) > 0)) then
                l_u = l_u + 1
                if (present(line)) then
                    neighbour = quad_idx(mn(1)-1, mn(4))
                    ! We substract 1 from index to comply with C/python indexing.
                    line(l_u,:) = (/ neighbour - 1, nod - 1 /)
                    cross_pix_coords(l_u,:) = (/ i0 - 1, j3 - 1, i0 - 1, j1 /)
                endif
            endif
        endif
        !!!!!!!!!!!!!!!!!!!!!!!!!
        !!!!! U - direction !!!!!
        !!!!!!!!!!!!!!!!!!!!!!!!!


        !!!!!!!!!!!!!!!!!!!!!!!!!
        !!!!! V - direction !!!!!
        !!!!!!!!!!!!!!!!!!!!!!!!!
        if (mn(4) < size(quad_idx, 2)) then
            if (lg(mn(1), mn(4)+1) == k .and. any(minval(area_mask(i0:i1,j1:j1+1), 2) > 0)) then
                l_v = l_v + 1
                if (present(line)) then
                    neighbour = quad_idx(mn(1), mn(4)+1)
                    ! We substract 1 from index to comply with C/python indexing.
                    line(l_v,:) = (/ nod - 1, neighbour - 1 /)
                    cross_pix_coords(l_v,:) = (/ i0 - 1, j1, i1, j1 /) ! Python indexing so -1 at start slice
                endif
            else
                if (lg(mn(1), mn(4)+1) == k-1 .and. any(minval(area_mask(i0:i2,j1:j1+1), 2) > 0)) then
                    l_v = l_v + 1
                    if (present(line)) then
                        neighbour = quad_idx(mn(1), mn(4)+1)
                        ! We substract 1 from index to comply with C/python indexing.
                        line(l_v,:) = (/ nod - 1, neighbour - 1 /)
                        cross_pix_coords(l_v,:) = (/ i0 - 1, j1, i2, j1 /) ! Python indexing so -1 at start slice
                    endif
                endif
                if (lg(mn(3), mn(4)+1) == k-1 .and. any(minval(area_mask(i3:i1,j1:j1+1), 2) > 0)) then
                    l_v = l_v + 1
                    if (present(line)) then
                        neighbour = quad_idx(mn(3), mn(4)+1)
                        ! We substract 1 from index to comply with C/python indexing.
                        line(l_v,:) = (/ nod - 1, neighbour - 1 /)
                        cross_pix_coords(l_v,:) = (/ i3 - 1, j1, i1, j1 /) ! Python indexing so -1 at start slice
                    endif
                endif
            endif
        endif
            
        if (mn(2) > 1) then
            if(lg(mn(1), mn(2)-1) == k-1 .and. any(minval(area_mask(i0:i2,max(1,j0-1):j0), 2) > 0)) then
                l_v = l_v + 1
                if (present(line)) then
                    neighbour = quad_idx(mn(1), mn(2)-1)
                    ! We substract 1 from index to comply with C/python indexing.
                    line(l_v,:) = (/ neighbour - 1, nod - 1 /)
                    cross_pix_coords(l_v,:) = (/ i0 - 1, j0 - 1, i2, j0 - 1/) ! Python indexing so -1 at start slice
                endif
            endif
            if(lg(mn(3), mn(2)-1) == k-1 .and. any(minval(area_mask(i3:i1,max(1,j0-1):j0), 2) > 0)) then
                l_v = l_v + 1
                if (present(line)) then
                    neighbour = quad_idx(mn(3), mn(2)-1)
                    ! We substract 1 from index to comply with C/python indexing.
                    line(l_v,:) = (/ neighbour - 1, nod - 1 /)
                    cross_pix_coords(l_v,:) = (/ i3 - 1, j0 - 1, i1, j0 - 1 /) ! Python indexing so -1 at start slice
                endif
            endif
        endif
        !!!!!!!!!!!!!!!!!!!!!!!!!
        !!!!! V - direction !!!!!
        !!!!!!!!!!!!!!!!!!!!!!!!!

    end subroutine set_2d_computational_lines


    subroutine set_quarter_admin(nodk, nodm, nodn, line, kcu, quarter_line, quarter_neighbour, liutot, livtot, n2dobc)

        use parameters, only : LINE_2D_BOUNDARY_EAST, LINE_2D_BOUNDARY_WEST, LINE_2D_BOUNDARY_SOUTH, LINE_2D_BOUNDARY_NORTH

        integer, intent(in) :: nodk(:)
        integer, intent(in) :: nodm(:)
        integer, intent(in) :: nodn(:)
        integer, intent(in) :: line(:, :)
        integer, intent(in) :: kcu(:)
        integer, intent(inout) :: quarter_line(:, :)
        integer, intent(inout) :: quarter_neighbour(:, :)
        integer, intent(in) :: liutot
        integer, intent(in) :: livtot
        integer, intent(in) :: n2dobc
        integer :: l
        integer :: quarter
        integer :: nodd
        integer :: nodu
        integer :: kd
        integer :: ku
        integer :: md
        integer :: mu
        integer :: nd
        integer :: nu
        integer :: nb


        !!!!!!!!!!!!!!!!
        !!  3  !!  4  !!
        !!!!!!!!!!!!!!!!
        !!  1  !!  2  !!
        !!!!!!!!!!!!!!!!
        ! Here we try to find all horizontal flow lines associated with a cell quarter. 
        ! For two adjacent cells of samen size both neighbouring quadrants have same flow line. 
        ! When adjacent cells differ in size due to refinement, each quadrant is associated with its own line for the larger cell. The smaller cell will have the same flow line for both quadrants. Hence the "if" structure.
        ! Same logic applies to finding neighbouring nodes for quarters.
        ! The cell quadrant index is illustrated above.
        do l=1, liutot
            nodd = line(l, 1) + 1 ! This is a 0-based python index, therefore +1
            nodu = line(l, 2) + 1
            kd = nodk(nodd)
            ku = nodk(nodu)
            md = nodm(nodd) 
            mu = nodm(nodu)
            nd = nodn(nodd)
            nu = nodn(nodu)
            if (ku==kd) then
                quarter_line(get_quarter_idx(nodd, 2), 1) = l - 1 ! This needs to be an index in Python again.
                quarter_line(get_quarter_idx(nodd, 4), 1) = l - 1
                quarter_line(get_quarter_idx(nodu, 1), 1) = l - 1
                quarter_line(get_quarter_idx(nodu, 3), 1) = l - 1
                quarter_neighbour(get_quarter_idx(nodd, 2), 1) = nodu - 1
                quarter_neighbour(get_quarter_idx(nodd, 4), 1) = nodu - 1
                quarter_neighbour(get_quarter_idx(nodu, 1), 1) = nodd - 1
                quarter_neighbour(get_quarter_idx(nodu, 3), 1) = nodd - 1
            elseif (ku == kd + 1) then
                if (nd == 2 * nu - 1) then
                    quarter_line(get_quarter_idx(nodd, 2), 1) = l - 1
                    quarter_line(get_quarter_idx(nodd, 4), 1) = l - 1
                    quarter_line(get_quarter_idx(nodu, 1), 1) = l - 1
                    quarter_neighbour(get_quarter_idx(nodd, 2), 1) = nodu - 1
                    quarter_neighbour(get_quarter_idx(nodd, 4), 1) = nodu - 1
                    quarter_neighbour(get_quarter_idx(nodu, 1), 1) = nodd - 1
                endif
                if (nd == 2 * nu) then
                    quarter_line(get_quarter_idx(nodd, 2), 1) = l - 1
                    quarter_line(get_quarter_idx(nodd, 4), 1) = l - 1
                    quarter_line(get_quarter_idx(nodu, 3), 1) = l - 1
                    quarter_neighbour(get_quarter_idx(nodd, 2), 1) = nodu - 1
                    quarter_neighbour(get_quarter_idx(nodd, 4), 1) = nodu - 1
                    quarter_neighbour(get_quarter_idx(nodu, 3), 1) = nodd - 1
                endif
            else if (kd == ku + 1) then
                if (nu == 2 * nd - 1) then
                    quarter_line(get_quarter_idx(nodd, 2), 1) = l - 1
                    quarter_line(get_quarter_idx(nodu, 1), 1) = l - 1
                    quarter_line(get_quarter_idx(nodu, 3), 1) = l - 1
                    quarter_neighbour(get_quarter_idx(nodd, 2), 1) = nodu - 1
                    quarter_neighbour(get_quarter_idx(nodu, 1), 1) = nodd - 1
                    quarter_neighbour(get_quarter_idx(nodu, 3), 1) = nodd - 1
                elseif (nu == 2 * nd) then
                    quarter_line(get_quarter_idx(nodd, 4), 1) = l - 1
                    quarter_line(get_quarter_idx(nodu, 1), 1) = l - 1
                    quarter_line(get_quarter_idx(nodu, 3), 1) = l - 1
                    quarter_neighbour(get_quarter_idx(nodd, 4), 1) = nodu - 1
                    quarter_neighbour(get_quarter_idx(nodu, 1), 1) = nodd - 1
                    quarter_neighbour(get_quarter_idx(nodu, 3), 1) = nodd - 1
                endif
            endif
        enddo

        ! Here we try to find all vertical flow lines associated with a cell quarter. 
        ! For two adjacent cells of samen size both neighbouring quadrants have same flow line. 
        ! When adjacent cells differ in size due to refinement, each quadrant is associated with its own line for the larger cell. The smaller cell will have the same flow line for both quadrants. Hence the "if" structure.
        ! Same logic applies to finding neighbouring nodes for quarters.
        ! The cell quadrant index is illustrated above.
        do l=liutot + 1, liutot+livtot
            nodd = line(l, 1) + 1
            nodu = line(l, 2) + 1 
            kd = nodk(nodd)
            ku = nodk(nodu)
            md = nodm(nodd) 
            mu = nodm(nodu)
            nd = nodn(nodd)
            nu = nodn(nodu)
            if (ku==kd) then
                quarter_line(get_quarter_idx(nodd, 3), 2) = l - 1
                quarter_line(get_quarter_idx(nodd, 4), 2) = l - 1
                quarter_line(get_quarter_idx(nodu, 1), 2) = l - 1
                quarter_line(get_quarter_idx(nodu, 2), 2) = l - 1
                quarter_neighbour(get_quarter_idx(nodd, 3), 2) = nodu - 1
                quarter_neighbour(get_quarter_idx(nodd, 4), 2) = nodu - 1
                quarter_neighbour(get_quarter_idx(nodu, 1), 2) = nodd - 1
                quarter_neighbour(get_quarter_idx(nodu, 2), 2) = nodd - 1
            elseif (ku == kd + 1) then
                if (md == 2 * mu - 1) then
                    quarter_line(get_quarter_idx(nodd, 3), 2) = l - 1
                    quarter_line(get_quarter_idx(nodd, 4), 2) = l - 1
                    quarter_line(get_quarter_idx(nodu, 1), 2) = l - 1
                    quarter_neighbour(get_quarter_idx(nodd, 3), 2) = nodu - 1
                    quarter_neighbour(get_quarter_idx(nodd, 4), 2) = nodu - 1
                    quarter_neighbour(get_quarter_idx(nodu, 1), 2) = nodd - 1
                endif
                if (md == 2 * mu) then
                    quarter_line(get_quarter_idx(nodd, 3), 2) = l - 1
                    quarter_line(get_quarter_idx(nodd, 4), 2) = l - 1
                    quarter_line(get_quarter_idx(nodu, 2), 2) = l - 1
                    quarter_neighbour(get_quarter_idx(nodd, 3), 2) = nodu - 1
                    quarter_neighbour(get_quarter_idx(nodd, 4), 2) = nodu - 1
                    quarter_neighbour(get_quarter_idx(nodu, 2), 2) = nodd - 1
                endif
            else if (kd == ku + 1) then
                if (mu == 2 * md - 1) then
                    quarter_line(get_quarter_idx(nodd, 3), 2) = l - 1
                    quarter_line(get_quarter_idx(nodu, 1), 2) = l - 1
                    quarter_line(get_quarter_idx(nodu, 2), 2) = l - 1
                    quarter_neighbour(get_quarter_idx(nodd, 3), 2) = nodu - 1
                    quarter_neighbour(get_quarter_idx(nodu, 1), 2) = nodd - 1
                    quarter_neighbour(get_quarter_idx(nodu, 2), 2) = nodd - 1
                elseif (mu == 2 * md) then
                    quarter_line(get_quarter_idx(nodd, 4), 2) = l - 1
                    quarter_line(get_quarter_idx(nodu, 1), 2) = l - 1
                    quarter_line(get_quarter_idx(nodu, 2), 2) = l - 1
                    quarter_neighbour(get_quarter_idx(nodd, 4), 2) = nodu - 1
                    quarter_neighbour(get_quarter_idx(nodu, 1), 2) = nodd - 1
                    quarter_neighbour(get_quarter_idx(nodu, 2), 2) = nodd - 1
                endif
            endif
        enddo

        do nb=1,n2dobc  !nodobc
            l = liutot + livtot + nb
            nodd = line(l, 1) + 1
            nodu = line(l, 2) + 1
            select case(kcu(l))
            case(LINE_2D_BOUNDARY_WEST)
                quarter_line(get_quarter_idx(nodu, 1), 1) = l - 1
                quarter_line(get_quarter_idx(nodu, 3), 1) = l
                quarter_neighbour(get_quarter_idx(nodu, 1), 1) = nodd - 1
                quarter_neighbour(get_quarter_idx(nodu, 3), 1) = nodd - 1
            case(LINE_2D_BOUNDARY_EAST)
                quarter_line(get_quarter_idx(nodd, 2), 1) = l - 1
                quarter_line(get_quarter_idx(nodd, 4), 1) = l - 1
                quarter_neighbour(get_quarter_idx(nodd, 2), 1) = nodu - 1
                quarter_neighbour(get_quarter_idx(nodd, 4), 1) = nodu - 1
            case(LINE_2D_BOUNDARY_SOUTH)
                quarter_line(get_quarter_idx(nodu, 1), 2) = l - 1
                quarter_line(get_quarter_idx(nodu, 2), 2) = l - 1
                quarter_neighbour(get_quarter_idx(nodu, 1), 2) = nodd - 1
                quarter_neighbour(get_quarter_idx(nodu, 2), 2) = nodd - 1
            case(LINE_2D_BOUNDARY_NORTH)
                quarter_line(get_quarter_idx(nodd, 3), 2) = l - 1
                quarter_line(get_quarter_idx(nodd, 4), 2) = l - 1
                quarter_neighbour(get_quarter_idx(nodd, 3), 2) = nodu - 1
                quarter_neighbour(get_quarter_idx(nodd, 4), 2) = nodu - 1
            end select
        enddo

    end subroutine set_quarter_admin


    function get_quarter_idx(nod, quadrant) result(idx)
        ! This function returns the quarter index based on the node and its quadrant index.
        !!!!!!!!!!!!!!!!
        !!  3  !!  4  !!
        !!!!!!!!!!!!!!!!
        !!  1  !!  2  !!
        !!!!!!!!!!!!!!!!
        integer, intent(in) :: nod
        integer, intent(in) :: quadrant
        integer :: idx

        idx = 4 * (nod - 1) + quadrant
    
    end function get_quarter_idx

end module m_cells

module m_array_utils

    implicit none 


    interface check_bounds
        module procedure :: check_bounds_d_1d
        module procedure :: check_bounds_d_2d
        module procedure :: check_bounds_i_1d
        module procedure :: check_bounds_i_2d
    end interface
    
    contains

    function check_bounds_d_1d(array, i0, i1) result(inbound)

        double precision, intent(in) :: array(:)
        integer, intent(in) :: i0
        integer, intent(in) :: i1
        logical :: inbound

        inbound = .FALSE.
        if (i0 >= lbound(array, 1) .and. i1 <= ubound(array, 1)) then
            if(i0 <= i1) then
                inbound = .TRUE.
            else
                inbound = .FALSE.
            endif
        else
            write(*,*) '** WARNING: Array out of bounds'
        endif

    end function check_bounds_d_1d

    function check_bounds_d_2d(array, i0, i1, axis_in) result(inbound)

        double precision, intent(in) :: array(:,:)
        integer, intent(in) :: i0
        integer, intent(in) :: i1
        integer, intent(in), optional :: axis_in
        integer :: axis
        logical :: inbound

        if (present(axis_in)) then
            axis = axis_in
        else
            axis = 1
        endif

        inbound = .FALSE.
        if (i0 >= lbound(array, axis) .and. i1 <= ubound(array, axis)) then
            if(i0 <= i1) then
                inbound = .TRUE.
            else
                write(*,*) '** WARNING: Indices in incorrect order.'
                inbound = .FALSE.
            endif
        else
            write(*,*) '** WARNING: Array out of bounds'
        endif

    end function check_bounds_d_2d

    function check_bounds_i_1d(array, i0, i1) result(inbound)

        integer, intent(in) :: array(:)
        integer, intent(in) :: i0
        integer, intent(in) :: i1
        logical :: inbound

        inbound = .FALSE.
        if (i0>=lbound(array, 1) .and. i1<=ubound(array, 1)) then
            if(i0 <= i1) then
                inbound = .TRUE.
            else
                inbound = .FALSE.
            endif
        else
            write(*,*) '** WARNING: Array out of bounds'
        endif

    end function check_bounds_i_1d

    function check_bounds_i_2d(array, i0, i1, axis_in) result(inbound)

        integer, intent(in) :: array(:,:)
        integer, intent(in) :: i0
        integer, intent(in) :: i1
        integer, intent(in), optional :: axis_in
        integer :: axis
        logical :: inbound

        if (present(axis_in)) then
            axis = axis_in
        else
            axis = 1
        endif

        inbound = .FALSE.
        if (i0>=lbound(array, axis) .and. i1<=ubound(array, axis)) then
            if(i0 <= i1) then
                inbound = .TRUE.
            else
                inbound = .FALSE.
            endif
        else
            write(*,*) '** WARNING: Array out of bounds'
        endif

    end function check_bounds_i_2d



end module m_array_utils

module parameters
    
    integer, parameter :: STRINGLEN = 1024
    double precision, parameter   :: NODATA = -9999.0d0
    real, parameter   :: NODATA_R = -9999.0
    
    integer, parameter :: CHUNK_SIZE = 1024
    integer, parameter :: COMPRESSION_LEVEL = 9    
    integer, parameter :: NODE_2D = 1,&
                          NODE_2D_GW = 2,&
                          NODE_1D = 3,&
                          NODE_1D_STOR = 4,&
                          NODE_2D_BOUND = 5,&
                          NODE_2D_GW_BOUND = 6,&
                          NODE_1D_BOUND = 7

    integer, parameter :: LINE_1D_EMBEDDED = 0,&
                          LINE_1D_ISOLATED = 1,&
                          LINE_1D_CONNECTED = 2,&
                          LINE_1D_LONG_CRESTED = 3,&
                          LINE_1D_SHORT_CRESTED = 4,&
                          LINE_1D_DOUBLE_CONNECTED = 5,&
                          LINE_1D2D_SINGLE_CONNECTED_CLOSED = 51,&
                          LINE_1D2D_SINGLE_CONNECTED_OPEN_WATER = 52,&
                          LINE_1D2D_DOUBLE_CONNECTED_CLOSED = 53,&
                          LINE_1D2D_DOUBLE_CONNECTED_OPEN_WATER = 54,&
                          LINE_1D2D_POSSIBLE_BREACH = 55,&
                          LINE_1D2D_ACTIVE_BREACH = 56,&
                          LINE_1D2D_GROUNDWATER = 57,&
                          LINE_2D = 100,&
                          LINE_2D_OBSTACLE = 101,&
                          LINE_2D_VERTICAL = 150,&
                          LINE_2D_GROUNDWATER = -150,&
                          LINE_2D_BOUNDARY_WEST = 200,&
                          LINE_2D_BOUNDARY_EAST = 300,&
                          LINE_2D_BOUNDARY_SOUTH = 400,&
                          LINE_2D_BOUNDARY_NORTH = 500,&
                          LINE_2D_GROUNDWATER_BOUNDARY_WEST = 600,&
                          LINE_2D_GROUNDWATER_BOUNDARY_EAST = 700,&
                          LINE_2D_GROUNDWATER_BOUNDARY_SOUTH = 800,&
                          LINE_2D_GROUNDWATER_BOUNDARY_NORTH = 900
    
end module parameters

module m_grid_utils

    implicit none

    contains

    function feature_in_bbox(feature_bbox, bbox) result(in_bbox)

        double precision, intent(in) :: feature_bbox(4)
        double precision, intent(in) :: bbox(4)
        logical :: in_bbox

        if((feature_bbox(1)>=bbox(1).and.feature_bbox(3)>=bbox(1)).or.&
            (feature_bbox(1)<=bbox(3).and.feature_bbox(3)<=bbox(1)).or.&
            (feature_bbox(2)>=bbox(2).and.feature_bbox(4)>=bbox(2)).or.&
            (feature_bbox(2)<=bbox(4).and.feature_bbox(4)<=bbox(4))) then
            in_bbox = .TRUE.
        else
            in_bbox = .FALSE.
        endif

    end function feature_in_bbox


    subroutine get_pix_corners(k, m, n, min_pix, i0, i1, j0, j1, i2, i3, j2, j3)

        integer(KIND=4), intent(in) :: k
        integer, intent(in) :: m
        integer, intent(in) :: n
        integer, intent(in) :: min_pix
        integer, intent(out) :: i0
        integer, intent(out) :: i1
        integer, intent(out) :: j0
        integer, intent(out) :: j1
        integer, intent(out), optional :: i2
        integer, intent(out), optional :: i3
        integer, intent(out), optional :: j2
        integer, intent(out), optional :: j3
        integer :: num_pix

        num_pix = min_pix*2**(k-1)

        i0 = (m-1)*num_pix + 1
        i1 = m*num_pix
        j0 = (n-1)*num_pix + 1
        j1 = n*num_pix

        if (present(i2)) then
            i2 = (m-1)*num_pix + int(0.5*num_pix)
            i3 = (m-1)*num_pix + int(0.5*num_pix) + 1
            j2 = (n-1)*num_pix + int(0.5*num_pix)
            j3 = (n-1)*num_pix + int(0.5*num_pix) + 1
        endif

    end subroutine get_pix_corners

    subroutine crop_pix_coords_to_raster(raster, i0, i1, j0, j1, i2, i3, j2, j3)

        integer, intent(in) :: raster(:,:)
        integer, intent(inout) :: i0
        integer, intent(inout) :: i1
        integer, intent(inout) :: j0
        integer, intent(inout) :: j1
        integer, intent(inout), optional :: i2
        integer, intent(inout), optional :: i3
        integer, intent(inout), optional :: j2
        integer, intent(inout), optional :: j3

        i0 = min(i0, size(raster, 1))
        j0 = min(j0, size(raster, 2))
        i1 = min(i1, size(raster, 1))
        j1 = min(j1, size(raster, 2))
        i2 = min(i2, size(raster, 1))
        j2 = min(j2, size(raster, 2))
        i3 = min(i3, size(raster, 1))
        j3 = min(j3, size(raster, 2))

    end subroutine crop_pix_coords_to_raster

    function pad_area_mask(raster, i0, i1, j0, j1) result(padded_raster)

        integer*1, intent(in) :: raster(:,:)
        integer, intent(in) :: i0
        integer, intent(in) :: i1
        integer, intent(in) :: j0
        integer, intent(in) :: j1
        integer*1, allocatable :: padded_raster(:, :)
        integer :: i_size, j_size, size_raster_i, size_raster_j

        size_raster_i = size(raster, 1)
        size_raster_j = size(raster, 2)
        i_size = max(0, i1, size_raster_i)
        j_size = max(0, j1, size_raster_j)
        allocate(padded_raster(1:i_size, 1:j_size))
        padded_raster = 0

        padded_raster(1:size_raster_i, 1:size_raster_j) = raster(1:size_raster_i, 1:size_raster_j)

    end function pad_area_mask

    function get_lg_corners(k, m, n) result(mn)

        integer, intent(in) :: k
        integer, intent(in) :: m
        integer, intent(in) :: n
        integer :: mn(4)
        integer :: num_cells
        
        num_cells = 1 * 2 ** (k - 1)
        mn(1) = (m-1)*num_cells + 1
        mn(2) = (n-1)*num_cells + 1
        mn(3) = m*num_cells
        mn(4) = n*num_cells

    end function get_lg_corners

    function get_cell_bbox(xorig, yorig, m, n, dx) result(bbox)

        double precision, intent(in) :: xorig
        double precision, intent(in) :: yorig
        integer, intent(in) :: m
        integer, intent(in) :: n
        double precision, intent(in) :: dx
        double precision :: bbox(4)

        bbox(1) = xorig + m * dx - dx
        bbox(2) = yorig + n * dx - dx
        bbox(3) = xorig + m * dx
        bbox(4) = yorig + n * dx

    end function get_cell_bbox

    
    function get_cell_geom(xorig, yorig, m, n, dx) result(cell_geom)

        double precision, intent(in) :: xorig
        double precision, intent(in) :: yorig
        integer, intent(in) :: m
        integer, intent(in) :: n
        double precision, intent(in) :: dx
        double precision :: x0, y0, x1, y1
        double precision :: cell_geom(5,2)

        x0 = xorig + m * dx - dx
        y0 = yorig + n * dx - dx
        x1 = xorig + m * dx
        y1 = yorig + n * dx

        cell_geom(1,:) = (/ x0, y0 /)
        cell_geom(2,:) = (/ x0, y1 /)
        cell_geom(3,:) = (/ x1, y1 /)
        cell_geom(4,:) = (/ x1, y0 /)
        cell_geom(5,:) = (/ x0, y0 /)
    
    end function get_cell_geom

    function find_cell_intersects(geom1, geom2) result (cross)

        double precision, intent(in) :: geom1(:,:)
        double precision, intent(in) :: geom2(:,:)
        double precision :: edge_geom(4)
        logical :: cross
        integer :: i, j
        double precision :: intersection(2)

        do i=1, size(geom1, 1) - 1
            do j=1, size(geom2, 1) - 1
                cross = .FALSE.
                intersection = -9999.0d0

                edge_geom = (/ geom2(j,1), geom2(j,2), geom2(j+1, 1) , geom2(j+1, 2) /)    
                call get_line_intersection(&
                    edge_geom, (/geom1(i, 1), geom1(i, 2), geom1(i+1, 1), geom1(i+1, 2) /), cross, intersection&
                )
                if (cross.eqv..TRUE.) then
                    !write(*,*) 'intersection x, y: ', intersection
                    return
                endif
            enddo
        enddo

    end function find_cell_intersects

    subroutine find_crossing(geom1,geom2,cross,xcross,ycross)
        
        implicit none
        
        double precision, intent(in) :: geom1(4), geom2(4)
        double precision :: x0,y0,x1,y1,x2,y2,x3,y3
        logical, intent(out) :: cross
        double precision, intent(out), optional :: xcross, ycross
        double precision :: aa0,aa1,bb0,bb1,cc0,cc1,ddi,ds0,ds1,ds2
        
        !> details First it finds the corresponding connection.
        !! Second, the orientation of levee with respect to grid is determined
        !! Third, It is determined which velocity points are connected and which flooding treshold it belongs.
        !> @param[in] x0, y0 coordinates of beginning of levee element
        !> @param[in] x1, y1 coordinates of end of levee element
        !> @param[in] x2, y2 start coordinates of the second line
        !> @param[in] x3, y3 end coordinates of the second line
        x0 = geom1(1)
        y0 = geom1(2)
        x1 = geom1(3)
        y1 = geom1(4)
        x2 = geom2(1)
        y2 = geom2(2)
        x3 = geom2(3)
        y3 = geom2(4)

        cross=.FALSE.
        if ((y3.eq.y2).and.(y0.gt.y2).and.(y1.gt.y2)) return
        if ((x3.eq.x2).and.(x0.gt.x2).and.(x1.gt.x2)) return
        if ((y3.eq.y2).and.(y0.lt.y2).and.(y1.lt.y2)) return
        if ((x3.eq.x2).and.(x0.lt.x2).and.(x1.lt.x2)) return
        if ((max(y0,y1).lt.min(y2,y3)).or.(min(y0,y1).gt.max(y2,y3))) return
        if ((max(x0,x1).lt.min(x2,x3)).or.(min(x0,x1).gt.max(x2,x3))) return
        
        aa0=y1-y0
        bb0=x0-x1
        cc0=x0*y1-x1*y0
        
        aa1=y3-y2
        bb1=x2-x3
        cc1=x2*y3-x3*y2

        ddi=aa0*bb1-bb0*aa1

        xcross=(cc0*bb1-bb0*cc1)/ddi
        ycross=(aa0*cc1-cc0*aa1)/ddi
        ds0=dsqrt((x3-x2)**2+(y3-y2)**2)
        ds1=dsqrt((x3-xcross)**2+(y3-ycross)**2)
        ds2=dsqrt((xcross-x2)**2+(ycross-y2)**2)
        
        if (ds0-1.0d-8>ds1+ds2.or.abs(ddi)>1.0d-8) then ! points are not on the same side of the levee or lines are not parallel
            cross = .TRUE.
        endif
        
    end subroutine find_crossing


    subroutine find_intersection(geom1, geom2, intersects, intersection)

        implicit none

        double precision, intent(in) :: geom1(4)
        double precision, intent(in) :: geom2(4)
        logical, intent(out) :: intersects
        double precision, intent(out), optional :: intersection(2)
        double precision :: a1
        double precision :: a2
        double precision :: b1
        double precision :: b2
        !real      :: x, y       ! intersect point
        double precision :: dx1
        double precision :: dx2
        double precision :: dy1
        double precision :: dy2
       
        intersects = .FALSE.
        if ((max(geom1(2),geom1(4)).lt.min(geom2(2),geom2(4))).or.(min(geom1(2),geom1(4)).gt.max(geom2(2),geom2(4)))) then
            return
        endif
        if ((max(geom1(1),geom1(3)).lt.min(geom2(1),geom2(3))).or.(min(geom1(1),geom1(3)).gt.max(geom2(1),geom2(3)))) then
            return
        endif

        dx1 = geom1(1) - geom1(3)
        dy1 = geom1(2) - geom1(4)
        if( dx1 == 0.0d0) then    ! in case this line is of the form y = b
            a1 = 0.0d0
            b1 = geom1(2)
        else
            a1= dy1 / dx1
            b1 = geom1(2) - a1*geom1(1)
        endif

        dx2 = geom2(1) - geom2(3)
        dy2 = geom2(2) - geom2(4)
        if(dx2 == 0.0d0) then    ! in case this line is of the form y = b
            a2 = 0.0d0
            b2 = geom2(2)
        else
            a2= dy2 / dx2
            b2 = geom2(2) - a2*geom2(1)
        endif
        
        !write(*,*) 'a1', a1, 'a2', a2, 'b1', b1, 'b2', b2

        if( (a1 - a2)<1.0d-5 ) then
            intersects = .FALSE.
            write(*,*) '** DEBUG: Lines do not intersect'
            return
        else
            intersects = .TRUE.
            if(present(intersection)) then
                intersection(1) = (b2-b1) / (a1-a2)
                intersection(2) = a1 * intersection(1) + b1
            endif
            return
        endif
    
    end subroutine find_intersection

    subroutine get_line_intersection(geom1, geom2, intersect, intersection)
        
        implicit none

        double precision, intent(in) :: geom1(4)
        double precision, intent(in) :: geom2(4)
        logical, intent(out) :: intersect
        double precision, intent(out), optional :: intersection(2)
        double precision :: s1_x, s1_y, s2_x, s2_y
        double precision :: s, t, det, eps

        intersect = .FALSE.

        if ((geom2(4).eq.geom2(2)).and.(geom1(2).gt.geom2(2)).and.(geom1(4).gt.geom2(2))) return
        if ((geom2(3).eq.geom2(1)).and.(geom1(1).gt.geom2(1)).and.(geom1(3).gt.geom2(1))) return
        if ((geom2(4).eq.geom2(2)).and.(geom1(2).lt.geom2(2)).and.(geom1(4).lt.geom2(2))) return
        if ((geom2(3).eq.geom2(1)).and.(geom1(1).lt.geom2(1)).and.(geom1(3).lt.geom2(1))) return
        if ((max(geom1(2),geom1(4)).lt.min(geom2(2),geom2(4))).or.(min(geom1(2),geom1(4)).gt.max(geom2(2),geom2(4)))) then
            return
        endif
        if ((max(geom1(1),geom1(3)).lt.min(geom2(1),geom2(3))).or.(min(geom1(1),geom1(3)).gt.max(geom2(1),geom2(3)))) then
            return
        endif

        eps = 1.0d-5
        s1_x = geom1(3) - geom1(1)
        s1_y = geom1(4) - geom1(2)
        s2_x = geom2(3) - geom2(1)
        s2_y = geom2(4) - geom2(2)

        det = -s2_x * s1_y + s1_x * s2_y
        if(det<=eps.and.det>=-eps) then !! Lines are linear
            return
        endif
        s = (-s1_y * (geom1(1) - geom2(1)) + s1_x * (geom1(2) - geom2(2))) / det
        t = ( s2_x * (geom1(2) - geom2(2)) - s2_y * (geom1(1) - geom2(1))) / det

        if (s >= 0 .and. s <= 1 .and. t >= 0 .and. t <= 1) then
        !! Collision detected
            if (present(intersection)) then
                intersection(1) = geom1(1) + (t * s1_x);
                intersection(2) = geom1(2) + (t * s1_y);
            endif
            intersect = .TRUE.
            return
        endif
        
    end subroutine get_line_intersection

    function geom_in_polygon(geom1, geom2) result(cross)

        double precision, intent(in) :: geom1(:,:)
        double precision, intent(in) :: geom2(:,:)
        integer :: in_polygon
        logical :: cross
        integer :: i

        cross = .FALSE.
        do i=1,size(geom2,1)-1
            call point_in_polygon(geom2(i,1), geom2(i,2), geom1(:,1), geom1(:,2), in_polygon)
            if (in_polygon==0.or.in_polygon==1) then
                cross = .TRUE.
                !write(*,*) 'intersection x, y: ', intersection
                return
            endif
        enddo

    end function geom_in_polygon

    subroutine point_in_polygon(p_x, p_y, poly_x, poly_y, in_polygon)

        implicit none

        double precision, intent(in) :: p_x
        double precision, intent(in) :: p_y
        double precision, intent(in) :: poly_x(:)
        double precision, intent(in) :: poly_y(:)
        integer :: i, j, n_vertices
        integer, intent(out) :: in_polygon
        
        double precision :: xi, yi, xj, yj
        logical :: ix, iy, jx, jy, eor
	
    !   EXCLUSIVE OR STATEMENT FUNCTION.
        eor(ix, iy) = (ix.or.iy) .and. .not.(ix.and.iy)
	
        in_polygon = -1
        n_vertices = size(poly_x)
	
        do i= 1, n_vertices
            xi = poly_x(i) - p_x
            yi = poly_y(i) - p_y
	!CHECK WHETHER THE POINT IN QUESTION IS AT THIS VERTEX.
            if( xi==0.0d0.and.yi==0.0d0) then
                in_polygon = 0
                return
            endif
	!J IS NEXT VERTEX NUMBER OF POLYGON.
            j = 1 + mod(i,n_vertices)
            xj = poly_x(j) - p_x
            yj = poly_y(j) - p_y
	!IS THIS LINE OF 0 LENGTH ?
            if(xi==xj.and.yi==yj ) then
                cycle
            endif
            ix = xi>=0.0d0
            iy = yi>=0.0d0
            jx = xj>=0.0d0
            jy = yj>=0.0d0
	!CHECK WHETHER (PX,PY) IS ON VERTICAL SIDE OF POLYGON.
            if(xi==0.0d0.and.xj==0.0d0.and.eor(iy,jy)) then
                in_polygon = 0
                return
            endif
	!CHECK WHETHER (PX,PY) IS ON HORIZONTAL SIDE OF POLYGON.
            if(yi==0.0d0.and.yj==0.0d0.and.eor(ix,jx)) then
                in_polygon = 0
                return
            endif
	!CHECK WHETHER BOTH ENDS OF THIS SIDE ARE COMPLETELY 1) TO RIGHT
	!OF, 2) TO LEFT OF, OR 3) BELOW (PX,PY).
            if(.not.((iy.or.jy).and.eor(ix,jx))) then
                cycle
            endif
	!DOES THIS SIDE OBVIOUSLY CROSS LINE RISING VERTICALLY FROM (PX,PY)
            if(.not.(iy.and.jy.and.eor(ix,jx))) then
                if((yi*xj-xi*yj)/(xj-xi)<0.0d0) then
                    cycle
                elseif((yi*xj-xi*yj)/(xj-xi)==0.0d0) then
                    in_polygon = 0
                    return
                else
                    in_polygon = -in_polygon
                endif
            else
                in_polygon = -in_polygon
            endif
	
        enddo

    end subroutine point_in_polygon


end module m_grid_utils
